//+---------------------------------------------------------------------------
//
//  Microsoft Windows
//  Copyright (C) Microsoft Corporation, 1992 - 1993.
//
//  File:       othrguid.h
//
//  History:    06-Jun-96   anandra     Created
//
//  Contents:   extern references for site guids and manifest constants
//              for dispids
//
//----------------------------------------------------------------------------

//
// Reserve 10000 GUID entries beginning 3050f160-98b5-11cf-bb82-00aa00bdce0b
// and ending at 30c38c70-98b5-11cf-bb82-00aa00bdce0b.
//
// See the next available GUID in ...\src\guids.txt
// Check procedure for using next available GUID with F3 procedures handbook
//

#ifndef __OTHRGUID_H__
#define __OTHRGUID_H__

// Use PUBLIC_GUID for GUIDs used outside FORMS3.DLL.
// Use PRIVATE_GUID for all other GUIDS.

#ifndef PUBLIC_GUID
#define PUBLIC_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8);
#endif

#ifndef PRIVATE_GUID
#define PRIVATE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8);
#endif



// Property Pages
#ifndef NO_PROPERTY_PAGE
PRIVATE_GUID(CLSID_CBackgroundPropertyPage,     0x3050f232, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CLSID_CCDGenericPropertyPage,      0x3050f17f, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CLSID_CCDAnchorPropertyPage,       0x3050f1fc, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CLSID_CInlineStylePropertyPage,    0x3050f296, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CLSID_CAnchorBrowsePropertyPage,   0x3050f3BB, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CLSID_CImageBrowsePropertyPage,    0x3050f3B3, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CLSID_CDocBrowsePropertyPage,      0x3050f3B4, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
#endif // NO_PROPERTY_PAGE
PRIVATE_GUID(SID_SHTMLProperyPageArg,           0x3050f404, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

PRIVATE_GUID(CLSID_CDwnBindInfo,                0x3050f3c2, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(  IID_IDwnBindInfo,                0x3050f3c3, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

PRIVATE_GUID(IID_IHistoryBindInfo,              0x3050f403, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

PUBLIC_GUID(SID_GetCaller,                      0x4717cc40, 0xbcb9, 0x11d0, 0x93, 0x36, 0x00, 0xa0, 0xc9, 0x0d, 0xca, 0xa9)
PUBLIC_GUID(CGID_ScriptSite,                    0x3050f3f1, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PRIVATE_GUID(CGID_DownloadObjectBindContext,    0x3050f3df, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

PUBLIC_GUID(CLSID_JSProtocol,                   0x3050f3B2, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PUBLIC_GUID(CLSID_ResProtocol,                  0x3050f3bc, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PUBLIC_GUID(CLSID_MailtoProtocol,               0x3050f3da, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PUBLIC_GUID(CLSID_ViewSourceProtocol,           0x3050f400, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PUBLIC_GUID(CLSID_AboutProtocol,                0x3050f406, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)
PUBLIC_GUID(CLSID_SysimageProtocol,             0x76E67A63, 0x06E9, 0x11D2, 0xA8, 0x40, 0x00, 0x60, 0x08, 0x05, 0x93, 0x82)

PRIVATE_GUID(CLSID_CHook,                       0x3050f500, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

PRIVATE_GUID(CGID_JavaParambagCompatHack,       0x3050F405, 0x98B5, 0x11CF, 0xBB, 0x82, 0x00, 0xAA, 0x00, 0xBD, 0xCE, 0x0B)

////////////////////////////////////////////////////////////////////////////////
//
// Scriptoid handlers:
//
////////////////////////////////////////////////////////////////////////////////

// {5AAF51B1-B1F0-11d1-B6AB-00A0C90833E9}
PUBLIC_GUID(CLSID_CCSSFilterHandler,            0x5aaf51b1, 0xb1f0, 0x11d1, 0xb6, 0xab, 0x0, 0xa0, 0xc9, 0x8, 0x33, 0xe9)
// {5AAF51B2-B1F0-11d1-B6AB-00A0C90833E9}
PUBLIC_GUID(CLSID_CPeerHandler,                 0x5aaf51b2, 0xb1f0, 0x11d1, 0xb6, 0xab, 0x0, 0xa0, 0xc9, 0x8, 0x33, 0xe9)
// {5AAF51B3-B1F0-11d1-B6AB-00A0C90833E9}
PUBLIC_GUID(CLSID_CHiFiUses,                    0x5aaf51b3, 0xb1f0, 0x11d1, 0xb6, 0xab, 0x0, 0xa0, 0xc9, 0x8, 0x33, 0xe9)
// {3050f4f0-98b5-11cf-bb82-00aa00bdce0b}
PUBLIC_GUID(CLSID_CSvrOMUses,                   0x3050f4f0, 0x98b5, 0x11cf, 0xbb, 0x82, 0x0, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

PRIVATE_GUID(IID_IScriptletHandler,             0xa001a870, 0xa7df, 0x11d1, 0x89, 0xbe, 0x00, 0x60, 0x08, 0xc3, 0xfb, 0xfc)
PRIVATE_GUID(IID_IScriptletHandlerConstructor,  0xa3d52a50, 0xb7ff, 0x11d1, 0xa3, 0x5a, 0x00, 0x60, 0x08, 0xc3, 0xfb, 0xfc)
PRIVATE_GUID(SID_ScriptletSite,                 0x22a98050, 0xa65d, 0x11d1, 0x89, 0xbe, 0x00, 0x60, 0x08, 0xc3, 0xfb, 0xfc)
PRIVATE_GUID(IID_IScriptletError,               0xdf9f3d20, 0xa670, 0x11d1, 0x89, 0xbe, 0x00, 0x60, 0x08, 0xc3, 0xfb, 0xfc)
PRIVATE_GUID(IID_IScriptletSite,                0xc5f21c30, 0xa7df, 0x11d1, 0x89, 0xbe, 0x00, 0x60, 0x08, 0xc3, 0xfb, 0xfc)

PUBLIC_GUID(CLSID_HTADoc,		                0x3050f5c8, 0x98b5, 0x11cf, 0xbb, 0x82, 0x00, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

// Service ID that handlers ask for on the scriptlet object to get at the
// internal IDispatchEx namespace.
PUBLIC_GUID(SID_ScriptletDispatch,              0x66289210, 0x6b18, 0x11d1, 0x8c, 0xac, 0x0, 0xa0, 0xc9, 0xf, 0xff, 0xc0)
PRIVATE_GUID(SID_SServerOM,                     0x3050f4f1, 0x98b5, 0x11cf, 0xbb, 0x82, 0x0, 0xaa, 0x00, 0xbd, 0xce, 0x0b)

#endif

