/******************************************************************************

  Source File:  Resource.H

  Resource Identifier Definitions for the Integrated Color Matching User
  Interface DLL

  Copyright (c) 1996 by Microsoft Corporation

  A Pretty Penny Enterprises Production

  Change History:
  12-14-96  a-robkj@microsoft.com   Added this header to the .H file
                                    originally generated by Developer Studio

******************************************************************************/

#include <dlgs.h>

//
// Resource ID for string table
//
#define ShortInstallString              1
#define ShortUninstallString            2
#define AdvancedString                  3

#define InstallProfileMenuString        4
#define UninstallProfileMenuString      5
#define AssociateMenuString             6

#define ProfilePropertyString           7
#define AssociatePropertyString         8
#define MessageBoxTitle                 9
#define AddProfileAssociation           10

#define AddButtonText                   11

#define DefaultSourceString             12
#define PerceptualString                13
#define Occupied0                       14
#define Occupied1                       15
#define Occupied2                       16

#define ClassMonitorString              17
#define ClassPrinterString              18
#define ClassScannerString              19
#define ClassLinkString                 20
#define ClassAbstractString             21
#define ClassColorSpaceString           22
#define ClassNamedString                23

#define NoDefaultProfile                24
#define NoProfileString                 25
#define NoPrintersInstalled             26
#define NoAdditionalInfo                27
#define NotColorPrinter                 28

#define InvalidProfileString            29
#define MismatchDeviceType              30
#define InstFailedWithName              31
#define UninstFailedWithName            32
#define AssocFailedWithName             33
#define DisassocFailedWithName          34

#define IccProfileFilterString          35
#define AllProfileFilterString          36
#define TooManyFileSelected             37

#define UnsupportedProfile              38

#define UninstallProfileContextMenuString      39
#define UninstallMultiProfileContextMenuString 40
#define InstallProfileContextMenuString        41
#define InstallMultiProfileContextMenuString   42
#define AssociateContextMenuString             43

#define AskRemoveDefault                       44

/////////////////////////////////////////////////////////////////////////////

//
// Resource ID for dialogs
//
#define DefaultIcon                     100
#define UninstalledIcon                 101

#define PrinterUI                       110
#define MonitorUI                       111
#define ScannerUI                       112
#define AddDeviceDialog                 113
#define ProfilePropertyPage             114
#define AssociateDevicePage             115

#define ProfileDescription              120
#define AdditionalProfileInfo           121
#define ProfileProducerInfo             122

#define AddDeviceButton                 130
#define RemoveDeviceButton              131
#define AddButton                       132
#define RemoveButton                    133
#define DefaultButton                   134
#define AutoSelButton                   135
#define ManualSelButton                 136

#define DeviceListControl               140
#define DeviceListControlText           141
#define ProfileListControl              142
#define ProfileListControlText          143
#define DescriptionText                 144
#define PrinterUIIcon                   145
#define AutoSelText                     146
#define ManualSelText                   147

#define MonitorName                     150
#define MonitorNameText                 151
#define DefaultProfile                  152
#define DefaultProfileText              153
#define ProfileFilename                 154

#define CMMDescription                  160
#define CMMIcon                         161
#define StatusIcon                      162

//
// SetupColorMatch UI resource IDs (0x4??)
//
#define ApplyButton                     psh1
#define SourceProfile                   edt1
#define EnableICM                       chx1
#define EnableBasic                     rad1
#define EnableProofing                  rad2
#define MonitorProfileLabel             stc1
#define PrinterProfileLabel             stc2
#define RenderingIntentLabel            stc3
#define TargetProfileLabel              stc4
#define TargetIntentLabel               stc5
#define RenderingIntentText1            stc6
#define SourceProfileLabel              stc7
#define MonitorProfile                  cmb1
#define PrinterProfile                  cmb2
#define RenderingIntent                 cmb3
#define TargetProfile                   cmb4
#define TargetIntent                    cmb5

//
// SetupColorMatch UI Dialog (1551)
//
#define ApplicationUI                   COLORMGMTDLGORD

