#include <platform.h>

typedef struct
{
    WORD            wVer;
    WORD            wCnt;
    PALETTEENTRY    ape[256];
} LOGPAL256;

const LOGPAL256 g_lpHalftone =
{
    0x0300, 256,
    {
        PALETTE_ENTRY( 0x00, 0x00, 0x00, 0x00 ),
        PALETTE_ENTRY( 0x80, 0x00, 0x00, 0x00 ),
        PALETTE_ENTRY( 0x00, 0x80, 0x00, 0x00 ),
        PALETTE_ENTRY( 0x80, 0x80, 0x00, 0x00 ),
        PALETTE_ENTRY( 0x00, 0x00, 0x80, 0x00 ),
        PALETTE_ENTRY( 0x80, 0x00, 0x80, 0x00 ),
        PALETTE_ENTRY( 0x00, 0x80, 0x80, 0x00 ),
        PALETTE_ENTRY( 0xC0, 0xC0, 0xC0, 0x00 ),
        PALETTE_ENTRY( 0xC0, 0xDC, 0xC0, 0x00 ),
        PALETTE_ENTRY( 0xA6, 0xCA, 0xF0, 0x00 ),
        PALETTE_ENTRY( 0x99, 0x33, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x33, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x33, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x66, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x66, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x66, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x66, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x66, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x66, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x99, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x99, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x99, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x99, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x99, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x99, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xCC, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xCC, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xCC, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xCC, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xCC, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xCC, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xEF, 0xD6, 0xC6, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xAD, 0xA9, 0x90, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xFF, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xFF, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xFF, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x33, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x00, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x00, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x00, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x00, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x00, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x00, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x33, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x33, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x33, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x33, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x33, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x33, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x66, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x66, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x66, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x66, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x66, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x66, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x99, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x99, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x99, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x99, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x99, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x99, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xCC, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xCC, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xCC, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xCC, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xCC, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x33, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xCC, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xFF, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xFF, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xFF, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xFF, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xFF, 0x33, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x00, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x00, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x00, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x00, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x00, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x00, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x33, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x33, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x33, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x33, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x33, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x33, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x66, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x66, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x66, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x66, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x66, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x66, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x99, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x99, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x99, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x99, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x99, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x99, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xCC, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xCC, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xCC, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xCC, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xCC, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xCC, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xFF, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xFF, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xFF, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xFF, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xFF, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xFF, 0x66, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x00, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x00, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x00, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x00, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x00, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x00, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x33, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x33, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x33, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x33, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x33, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x33, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x66, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x66, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x66, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x66, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x66, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x66, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x99, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x99, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x99, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x99, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x99, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x99, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xCC, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xCC, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xCC, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xCC, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xCC, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xCC, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xFF, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xFF, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xFF, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xFF, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xFF, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xFF, 0x99, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x00, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x00, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x00, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x00, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x00, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x00, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x33, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x33, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x33, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x33, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x33, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x33, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x66, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x66, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x66, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x66, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x66, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x66, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x99, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x99, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x99, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x99, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x99, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x99, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xCC, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xCC, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xCC, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xCC, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xCC, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xCC, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xFF, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xFF, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xFF, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xFF, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xFF, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xFF, 0xCC, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xA5, 0x00, 0x21, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xD6, 0x00, 0x93, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x00, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x00, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x00, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x50, 0x50, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x33, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x33, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x33, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x33, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x33, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x33, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x66, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x66, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x66, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x66, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x66, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x66, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0x99, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x99, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x99, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x99, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x99, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x99, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x00, 0xCC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xCC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xCC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xCC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xCC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xCC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0xFF, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0xFF, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0xFF, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xFF, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0x7C, 0x80, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x04, 0x04, 0x04, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x08, 0x08, 0x08, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x0C, 0x0C, 0x0C, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x11, 0x11, 0x11, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x16, 0x16, 0x16, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x1C, 0x1C, 0x1C, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x22, 0x22, 0x22, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x29, 0x29, 0x29, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x39, 0x39, 0x39, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x42, 0x42, 0x42, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x4D, 0x4D, 0x4D, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x55, 0x55, 0x55, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x5F, 0x5F, 0x5F, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x77, 0x77, 0x77, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x86, 0x86, 0x86, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x96, 0x96, 0x96, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xB2, 0xB2, 0xB2, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCB, 0xCB, 0xCB, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xD7, 0xD7, 0xD7, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xDD, 0xDD, 0xDD, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xE3, 0xE3, 0xE3, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xEA, 0xEA, 0xEA, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xF1, 0xF1, 0xF1, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xF8, 0xF8, 0xF8, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xE7, 0xE7, 0xD6, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0xEC, 0xFF, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x33, 0x00, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x66, 0x00, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0x99, 0x00, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xCC, 0x00, 0x00, PC_NOCOLLAPSE ),
        PALETTE_ENTRY( 0xFF, 0xFB, 0xF0, 0x00 ),
        PALETTE_ENTRY( 0xA0, 0xA0, 0xA4, 0x00 ),
        PALETTE_ENTRY( 0x80, 0x80, 0x80, 0x00 ),
        PALETTE_ENTRY( 0xFF, 0x00, 0x00, 0x00 ),
        PALETTE_ENTRY( 0x00, 0xFF, 0x00, 0x00 ),
        PALETTE_ENTRY( 0xFF, 0xFF, 0x00, 0x00 ),
        PALETTE_ENTRY( 0x00, 0x00, 0xFF, 0x00 ),
        PALETTE_ENTRY( 0xFF, 0x00, 0xFF, 0x00 ),
        PALETTE_ENTRY( 0x00, 0xFF, 0xFF, 0x00 ),
        PALETTE_ENTRY( 0xFF, 0xFF, 0xFF, 0x00 ),
    }
};

const BYTE g_abWin95CMAP[32768] = {
  0, 11, 11, 12, 60, 60, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 11, 11, 12, 13, 60, 60, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 11, 12, 13, 13, 14, 60, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 12, 13, 13, 14, 14, 66, 66, 66, 66, 66,101,101,101,101,101,  4,  4,166,166,
166,166,166,199,199,199,199,199,199,199,252,252,252,
 33, 33, 14, 14, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,252,252,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,199,252,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,199,200,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,199,205,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,205,205,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,  6,  6,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,  6,  6,  6,  6,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2,  2, 72, 72, 72, 72, 72, 72,107,107,107,  6,  6,  6,  6,  6,  6,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2,  2, 78, 78, 78, 78, 78, 78,112,112,112,  6,  6,  6,  6,  6,  6,
129,129,129,178,178,178,178,178,178,178,211,211,211,
  2,  2,  2, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,  6,  6,  6,  6,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,  6,  6,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
250,250,250,250, 84, 84, 84, 84, 84,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
250,250,250,250,250, 84, 84, 84,123,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
250,250,250,250,250,250, 90,123,123,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
 11, 11, 12, 13, 60, 60, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 11, 12, 13, 13, 14, 60, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 12, 13, 13, 14, 14, 15, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 13, 13, 14, 14, 15, 15, 66, 66, 66, 66,101,101,101,101,101,  4,  4,166,166,
166,166,166,199,199,199,199,199,199,199,252,252,252,
 33, 14, 14, 15, 15, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,252,252,
 33, 33, 15, 15, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,200,200,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,200,200,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,200,200,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,199,205,205,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,  6,  6,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,  6,  6,  6,  6,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2,  2, 72, 72, 72, 72, 72, 72,107,107,107,  6,  6,  6,  6,  6,  6,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2,  2, 78, 78, 78, 78, 78, 78,112,112,112,  6,  6,  6,  6,  6,  6,
129,129,129,178,178,178,178,178,178,178,211,211,211,
  2,  2,  2, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,  6,  6,  6,  6,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,  6,  6,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
250,250,250,250, 84, 84, 84, 84, 84,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
250,250,250,250,250, 90, 90, 90,123,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
250,250,250,250,250, 90, 90, 90,123,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
 11, 12, 13, 13, 14, 60, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 12, 13, 13, 14, 14, 15, 60, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 13, 13, 14, 14, 15, 15, 15, 60, 60, 60, 95, 95, 95, 95,  4,  4,  4,  4,133,
133,133,133,161,161,161,161,161,161,161,252,252,252,
 13, 14, 14, 15, 15, 15, 16, 16, 66, 66,101,101,101,101,101,  4,  4,166,166,
166,166,166,199,199,199,199,199,199,199,252,252,252,
 14, 14, 15, 15, 15, 16, 16, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,200,200,200,
 33, 15, 15, 15, 16, 16, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,200,200,200,
 33, 33, 15, 16, 16, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,200,200,200,
 33, 33, 33, 16, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,200,200,200,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,200,200,200,
 33, 33, 33, 66, 66, 66, 66, 66, 66, 66,101,101,101,101,101,101,166,166,166,
166,166,166,199,199,199,199,199,199,199,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,107,138,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
 39, 39, 39, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,107,  6,  6,138,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2, 72, 72, 72, 72, 72, 72, 72,107,107,107,107,  6,  6,  6,  6,138,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2,  2, 72, 72, 72, 72, 72, 72,107,107,107,  6,  6,  6,  6,  6,  6,
138,138,138,172,172,172,172,172,172,172,205,205,205,
  2,  2,  2,  2, 78, 78, 78, 78, 78, 78,112,112,112,  6,  6,  6,  6,  6,  6,
129,129,129,178,178,178,178,178,178,178,211,211,211,
  2,  2,  2, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,  6,  6,  6,  6,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,  6,  6,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 45, 45, 45, 78, 78, 78, 78, 78, 78, 78,112,112,112,112,112,112,129,129,129,
129,129,129,178,178,178,178,178,178,178,211,211,211,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
 51, 51, 51, 84, 84, 84, 84, 84, 84, 84,118,118,118,118,118,118,149,149,149,
149,149,149,184,184,184,184,184,184,184,217,217,217,
250,250,250,250, 90, 90, 90, 90, 90,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
250,250,250,250, 90, 90, 90, 90, 90,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
250,250,250,250, 90, 90, 90, 90, 90,123,123,123,123,123,123,123,155,155,155,
155,155,155,190,190,190,190,190,190,190,254,254,254,
 12, 13, 13, 14, 14, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96,  4,  4,162,162,
162,162,162,196,196,196,196,196,196,196,252,252,252,
 13, 13, 14, 14, 15, 15, 61, 61, 61, 61, 96, 96, 96, 96, 96,  4,  4,162,162,
162,162,162,196,196,196,196,196,196,196,252,252,252,
 13, 14, 14, 15, 15, 15, 16, 16, 61, 61, 96, 96, 96, 96, 96,  4,  4,162,162,
162,162,162,196,196,196,196,196,196,196,252,252,252,
 14, 14, 15, 15, 15, 16, 16, 17, 17, 17,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 14, 15, 15, 15, 16, 16, 17, 17, 17, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 15, 15, 16, 16, 17, 17, 17, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 16, 17, 17, 17, 67, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 17, 17, 17, 67, 67, 67, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 17, 67, 67, 67, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,  6,  6,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
  2,  2,  2, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,  6,  6,  6,  6,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
  2,  2,  2, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,  6,  6,  6,  6,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,  6,  6,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
250,250,250, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
250,250,250, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
250,250,250, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 29, 29, 14, 14, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,252,252,
 29, 14, 14, 15, 15, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,252,252,
 14, 14, 15, 15, 15, 16, 16, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,200,200,200,
 14, 15, 15, 15, 16, 16, 17, 17, 17, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 15, 15, 16, 16, 17, 17, 17, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 16, 17, 17, 17, 67, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 17, 17, 17, 67, 67, 67, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 17, 67, 67, 67, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 67, 21, 21, 21, 20,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
250,250, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
250,250, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,196,252,
 29, 29, 15, 15, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,200,200,
 29, 15, 15, 15, 16, 16, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,200,200,200,
 34, 15, 15, 16, 16, 17, 17, 17, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 16, 17, 17, 17, 67, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 17, 17, 17, 67, 67, 67, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 17, 67, 67, 67, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 67, 21, 21, 21, 20,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 21, 21, 21, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 20,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 52, 90, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
250, 90, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,196,200,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,200,200,
 29, 29, 15, 16, 16, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,200,200,200,
 34, 34, 16, 16, 17, 17, 17, 67, 67, 67,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 16, 17, 17, 17, 67, 67, 67, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 17, 67, 67, 67, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 67, 21, 21, 21, 20,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 21, 21, 21, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 21, 21, 21, 20, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 73, 73, 73, 20, 20,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 52, 90, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 90, 90, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,196,197,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,200,200,
 29, 29, 29, 16, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,200,200,200,
 34, 34, 16, 17, 17, 17, 67, 67, 67, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 17, 67, 67, 67, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 67, 21, 21, 21, 20,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 21, 21, 21, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 21, 21, 21, 20, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 21, 21, 21, 20, 20, 20, 20, 19, 19,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 73, 73, 20, 20, 19, 19,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 19,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 52, 90, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 57, 90, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,197,197,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,196,197,197,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,200,200,200,
 34, 34, 34, 17, 17, 67, 67, 67, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 67, 21, 21, 21, 20,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 21, 21, 21, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 21, 21, 21, 20, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 21, 21, 21, 20, 20, 20, 20, 19, 19,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 21, 21, 20, 20, 20, 20, 19, 19, 19, 18, 18,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 73, 20, 20, 19, 19, 19, 18, 18,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 19, 19, 18, 18,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 18, 18,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 18,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 73,108,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 57, 57, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 57, 57, 90, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,197,197,197,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,197,197,197,
 29, 29, 29, 61, 61, 61, 61, 61, 61, 61, 96, 96, 96, 96, 96, 96,162,162,162,
162,162,162,196,196,196,196,196,196,196,197,197,197,
 34, 34, 34, 17, 67, 67, 67, 21, 21, 21,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 67, 21, 21, 21, 20,102,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 67, 21, 21, 21, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 67, 21, 21, 21, 20, 20, 20, 20,102,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 21, 21, 21, 20, 20, 20, 20, 19, 19,102,102,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 21, 21, 20, 20, 20, 20, 19, 19, 19, 18, 18,102,102,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 34, 34, 34, 21, 20, 20, 20, 20, 19, 19, 19, 18, 18, 18, 18,234,134,134,134,
134,134,134,167,167,167,167,167,167,167,200,200,200,
 40, 40, 40, 73, 73, 20, 20, 19, 19, 19, 18, 18, 18, 18,234,234,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 19, 19, 18, 18, 18, 18,234,234,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 18, 18, 18, 18,234,234,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 18, 18, 18,234,234,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73, 18,234,234,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 40, 40, 40, 73, 73, 73, 73, 73, 73,234,234,108,108,108,108,108,139,139,139,
139,139,139,173,173,173,173,173,173,173,206,206,206,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 46, 46, 46, 79, 79, 79, 79, 79, 79, 79,113,113,113,113,113,113,144,144,144,
144,144,144,179,179,179,179,179,179,179,212,212,212,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 52, 52, 52, 85, 85, 85, 85, 85, 85, 85,119,119,119,119,119,119,150,150,150,
150,150,150,185,185,185,185,185,185,185,218,218,218,
 57, 57, 57, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 57, 57, 57, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 57, 57, 57, 90, 90, 90, 90, 90, 90, 90,124,124,124,124,124,124,156,156,156,
156,156,156,191,191,191,191,191,191,191,223,223,223,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 20,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 20, 20,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 20, 20, 19, 19,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 20, 20, 19, 19, 19, 18, 18,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 20, 20, 19, 19, 19, 18, 18, 18, 18,234,234,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 41, 41, 41, 74, 74, 74, 74, 19, 19, 18, 18, 18, 18,234,234,234,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 18, 18, 18, 18,234,234,234,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 18, 18, 18,234,234,234,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 18,234,234,234,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,234,109,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,109,109,109,109,235,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 19,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 19, 19, 18, 18,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 19, 19, 18, 18, 18, 18,234,234,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 41, 41, 41, 74, 74, 74, 74, 74, 18, 18, 18, 18,234,234,234,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 18, 18, 18,234,234,234,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 18,234,234,234,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,234,109,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,109,109,109,109,235,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,109,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,235,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97, 97,135,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 18, 18,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 18, 18, 18, 18,234,234,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 41, 41, 41, 74, 74, 74, 74, 74, 18, 18, 18,234,234,234,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 18,234,234,234,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,234,109,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,109,109,109,109,235,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,109,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,235,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,235,235,235,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97,  5,  5,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97,  5,  5,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 30, 30, 30, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97, 97,  5,  5,135,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 18,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 18, 18, 18,234,234,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 18,234,234,234,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,234,109,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,109,109,109,109,235,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,109,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,235,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3, 74, 74, 74, 74, 74, 74, 74,109,109,235,235,235,235,235,248,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3, 80, 80, 80, 80, 80, 80, 80,114,114,114,235,235,235,248,248,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,248,248,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
  1,  1,  1, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97,  5,  5,  5,  5,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
  1,  1,  1, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97,  5,  5,  5,  5,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
  1,  1,  1, 62, 62, 62, 62, 62, 62, 62, 97, 97, 97, 97,  5,  5,  5,  5,135,
135,135,135,163,163,163,163,163,163,163,197,197,197,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,  5,  5,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 18,234,234,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,234,109,109,109,109,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,109,109,109,109,235,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,109,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,235,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3, 74, 74, 74, 74, 74, 74, 74,109,109,235,235,235,235,235,248,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3,  3, 74, 74, 74, 74, 74, 74,109,235,235,235,235,235,248,248,248,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3,  3, 80, 80, 80, 80, 80, 80,114,114,235,235,235,248,248,248,236,
145,145,145,180,180,180,180,180,180,180,213,213,213,
  3,  3,  3, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,248,248,248,236,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,248,236,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
  1,  1,  1,  1, 62, 62, 62, 62, 62, 62, 97, 97, 97,  5,  5,  5,  5,  5,  5,
135,135,135,163,163,163,163,163,163,163,197,197,197,
  1,  1,  1,  1, 62, 62, 62, 62, 62, 62, 97, 97, 97,  5,  5,  5,  5,  5,  5,
135,135,135,163,163,163,163,163,163,163,197,197,197,
  1,  1,  1,  1, 62, 62, 62, 62, 62, 62, 97, 97, 97,  5,  5,  5,  5,  5,  5,
135,135,135,163,163,163,163,163,163,163,197,197,197,
  1,  1,  1, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,  5,  5,  5,  5,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68, 68,103,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 35, 35, 35, 68, 68, 68, 68, 68, 68,234,234,103,103,103,103,103,140,140,140,
140,140,140,168,168,168,168,168,168,168,201,201,201,
 41, 41, 41, 74, 74, 74, 74, 74, 74,234,234,109,109,109,109,235,174,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,109,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
 41, 41, 41, 74, 74, 74, 74, 74, 74, 74,109,109,109,235,235,235,235,174,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3, 74, 74, 74, 74, 74, 74, 74,109,109,235,235,235,235,235,248,174,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3,  3, 74, 74, 74, 74, 74, 74,109,235,235,235,235,235,248,248,248,
174,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3,  3, 74, 74, 74, 74, 74, 74,235,235,235,235,235,248,248,248,236,
236,174,174,207,207,207,207,207,207,207,230,230,230,
  3,  3,  3,  3, 80, 80, 80, 80, 80, 80,114,235,235,235,248,248,248,236,236,
236,236,145,180,180,180,180,180,180,180,213,213,213,
  3,  3,  3,  3, 80, 80, 80, 80, 80, 80,114,114,114,248,248,248,236,236,236,
236,145,145,180,180,180,180,180,180,180,213,213,213,
  3,  3,  3, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,248,236,236,236,236,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,236,236,236,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,236,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 47, 47, 47, 80, 80, 80, 80, 80, 80, 80,114,114,114,114,114,114,145,145,145,
145,145,145,180,180,180,180,180,180,180,213,213,213,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 53, 53, 53, 86, 86, 86, 86, 86, 86, 86,151,151,151,151,151,151,157,157,157,
157,157,157,186,186,186,186,186,186,186,219,219,219,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
 57, 57, 57, 91, 91, 91, 91, 91, 91, 91,228,228,228,228,228,228,192,192,192,
192,192,192,224,224,224,224,224,224,224,232,232,232,
  1,  1,  1,  1, 63, 63, 63, 63, 63, 63, 98, 98, 98,  5,  5,  5,  5,  5,  5,
131,131,131,164,164,164,164,164,164,164,198,198,198,
  1,  1,  1,  1, 63, 63, 63, 63, 63, 63, 98, 98, 98,  5,  5,  5,  5,  5,  5,
131,131,131,164,164,164,164,164,164,164,198,198,198,
  1,  1,  1,  1, 63, 63, 63, 63, 63, 63, 98, 98, 98,  5,  5,  5,  5,  5,  5,
131,131,131,164,164,164,164,164,164,164,198,198,198,
  1,  1,  1, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,  5,  5,  5,  5,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,235,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,235,235,235,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3, 75, 75, 75, 75, 75, 75, 75,110,110,110,235,235,235,248,248,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3,  3, 75, 75, 75, 75, 75, 75,110,110,235,235,235,248,248,248,236,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3,  3, 75, 75, 75, 75, 75, 75,110,235,235,235,248,248,248,236,236,
236,236,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3,  3, 81, 81, 81, 81, 81, 81,115,115,235,248,248,248,236,236,236,
236,237,237,181,181,181,181,181,181,181,214,214,214,
  3,  3,  3,  3, 81, 81, 81, 81, 81, 81,115,115,115,248,248,236,236,236,236,
237,237,237,181,181,181,181,181,181,181,214,214,214,
  3,  3,  3, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,236,236,236,236,237,
237,237,237,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,236,237,237,
237,237,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,237,237,237,
237,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,237,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
  1,  1,  1,233, 63, 63, 63, 63, 63, 63, 98, 98, 98, 98,  5,  5,  5,  5,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
  1,  1,  1,233, 63, 63, 63, 63, 63, 63, 98, 98, 98, 98,  5,  5,  5,  5,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
  1,  1,  1,233, 63, 63, 63, 63, 63, 63, 98, 98, 98, 98,  5,  5,  5,  5,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,  5,  5,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,248,248,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,248,248,248,236,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3,  3, 75, 75, 75, 75, 75, 75,110,110,110,248,248,248,236,236,236,
236,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3,  3, 81, 81, 81, 81, 81, 81,115,115,115,248,248,236,236,236,236,
237,237,237,181,181,181,181,181,181,181,214,214,214,
  3,  3,  3, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,236,236,236,236,237,
237,237,237,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,236,237,237,
237,237,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,237,237,237,
237,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,237,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,146,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 31, 31, 31,233, 63, 63, 63, 63, 63, 63, 98, 98, 98, 98, 98,  5,  5,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31, 31, 31,233, 63, 63, 63, 63, 63, 63, 98, 98, 98, 98, 98,  5,  5,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31, 31, 31,233, 63, 63, 63, 63, 63, 63, 98, 98, 98, 98, 98,  5,  5,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,248,236,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,248,236,236,236,236,
141,141,141,175,175,175,175,175,175,175,208,208,208,
  3,  3,  3, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,236,236,236,236,237,
237,237,237,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,236,237,237,
237,237,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,237,237,237,
237,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,237,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,146,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115, 28,146,146,
146,146,146,239,181,181,181,181,181,181,214,214,214,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120, 28, 28,152,
152,152,239,239,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 31, 31,233,233,233, 63, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31, 31,233,233,233, 63, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31, 31,233,233,233, 63, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 36, 36, 36,233, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,236,236,236,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,236,237,237,
237,237,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,237,237,237,
237,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,237,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,146,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115, 28,146,146,
146,146,146,239,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115, 28, 28, 28, 28,
146,146,239,239,239,181,181,181,181,181,214,214,214,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120, 28, 28, 28, 28, 
28,239,239,239,239,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,239,239,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 31, 31,233,233,233,233, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31, 31,233,233,233,233, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31, 31,233,233,233,233, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 36, 36,233,233,233, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,236,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,236,237,237,237,
237,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,237,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,146,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115, 28, 28,146,
146,146,146,239,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115, 28, 28, 28, 28, 
28,146,239,239,239,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115, 28, 28, 28, 28, 
28,239,239,239,239,181,181,181,181,181,214,214,214,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120, 28, 28, 28, 28, 
28,239,239,239,239,239,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120, 28, 28, 28,152,
152,239,239,239,239,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,239,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,187,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,  8,187,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,  8,  8,187,187,187,187,187,220,220,220,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 31,233,233,233,233,233, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31,233,233,233,233,233, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 31,233,233,233,233,233, 63, 63, 63, 63, 98, 98, 98, 98, 98, 98,131,131,131,
131,131,131,164,164,164,164,164,164,164,198,198,198,
 36, 36,233,233,233, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 36, 36, 36, 69, 69, 69, 69, 69, 69, 69,104,104,104,104,104,104,130,130,130,
130,130,130,169,169,169,169,169,169,169,202,202,202,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 42, 42, 42, 75, 75, 75, 75, 75, 75, 75,110,110,110,110,110,110,141,141,141,
141,141,141,175,175,175,175,175,175,175,208,208,208,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,237,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115,115,237,237,146,
146,146,146,181,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115, 28, 28, 28,146,
146,146,146,239,181,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115, 28, 28, 28, 28, 
28,146,239,239,239,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115,115, 28, 28, 28, 28, 
28, 28,239,239,239,181,181,181,181,181,214,214,214,
 48, 48, 48, 81, 81, 81, 81, 81, 81, 81,115,115,115,115, 28, 28, 28, 28, 28, 
28,239,239,239,239,239,181,181,181,181,214,214,214,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120, 28, 28, 28, 28, 28, 
28,239,239,239,239,239,  7,  7,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120, 28, 28, 28, 28, 
28,239,239,239,239,  7,  7,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,239,239,  7,  7,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,  7,  7,187,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,152,  8,  8,  8,187,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,  8,  8,  8,  8,  8,187,187,187,220,220,220,
 54, 54, 54, 87, 87, 87, 87, 87, 87, 87,120,120,120,120,120,120,152,152,152,
152,152,  8,  8,  8,  8,  8,  8,187,187,220,220,220,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,  8,  8,  8,  8,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 58, 58, 58, 92, 92, 92, 92, 92, 92, 92,125,125,125,125,125,125,158,158,158,
158,158,158,193,193,193,193,193,193,193,225,225,225,
 32,233,233,233,233,233, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32,233,233,233,233,233, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32,233,233,233,233,233, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 37, 37,233,233,233,233, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116, 28, 28,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116, 28, 28, 28, 28,
147,147,239,239,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116, 28, 28, 28, 28, 
28, 28,239,239,239,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116, 28, 28, 28, 28, 28, 
28,239,239,239,239,239,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116, 28, 28, 28, 28, 28, 
28,239,239,239,239,239,  7,  7,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121, 28, 28, 28, 28, 28, 
28,239,239,239,239,  7,  7,  7,  7,  7,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121, 28, 28, 28, 28, 
28,239,239,239,  7,  7,  7,  7,  7,238,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121, 28, 28,153,
153,239,239,  7,  7,  7,  7,  7,238,238,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,  7,238,238,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,  8,  8,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,  8,  8,  8,  8,  8,  8,  8,  8,188, 25, 25, 25,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,  8,  8,  8,  8,  8,  8,  8,  8, 25, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,  8,  8,  8,  8,  8,  8,  8, 25, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,  8,  8,  8,194,194,194,194, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,194,226,226,226,
 32, 32, 32,233, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32,233, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32,233, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116, 28, 28,147,
147,147,239,239,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116, 28, 28, 28, 28,
147,239,239,239,239,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116, 28, 28, 28, 28, 
28,239,239,239,239,  7,  7,182,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121, 28, 28, 28, 28, 
28,239,239,239,  7,  7,  7,  7,  7,238,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121, 28, 28, 28,153,
153,239,239,  7,  7,  7,  7,  7,238,238,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,  7,238,238,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,238,238,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,  8,188,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,  8,  8,188,240, 25, 25, 25,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,  8,  8,  8,  8,  8,  8,  8,  8, 25, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,  8,  8,  8,  8,  8,  8,194, 25, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,  8,  8,194,194,194,194,194, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,194,226,226,226,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99,132,132,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,239,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116, 28, 28,147,
147,147,239,239,  7,  7,182,182,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121, 28, 28, 28,153,
153,239,239,  7,  7,  7,  7,  7,238,238,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,  7,238,238,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,238,238,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,  7,238,238,188,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,188,188,188,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,  8,188,240,240, 25, 25, 25,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,  8,  8,240,240, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,  8,  8,  8,  8,  8,194,194, 25, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,  8,194,194,194,194,194,194, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,194,226,226,226,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99, 24, 24,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99, 24, 24,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 99, 24, 24,132,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,  7,  7,182,182,182,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,  7,238,238,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,238,238,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,  7,238,238,188,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,238,238,188,188,188,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  8,  8,188,188,188,240,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,188,240,240,240,241, 25, 25,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,  8,240,240,241, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,  8,  8,  8,194,194,241,241, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,194, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,194,226,226,226,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24,
132,132,132,165,165,165,165,165,165,165,128,128,128,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105, 24,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,  7,182,182,182,182,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  7,  7,  7,  7,238,238,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,  7,238,238,188,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,238,238,188,188,188,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,238,238,188,188,188,240,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  8,188,188,188,240,240,240,241,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  8,  8,188,240,240,240,241,241, 25, 25,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,  8,  8,  8,  8,240,240,241,241,242, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,  8,  8,194,194,241,241,242,242, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,242, 25, 25, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,194,226,226,226,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24, 
24, 24,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24, 
24, 24,132,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24, 
24, 24,132,165,165,165,165,165,165,165,128,128,128,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105, 24, 24,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 23,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,  7,238,238,188,188,188,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7,238,238,188,188,188,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,238,238,188,188,188,240,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153, 26,188,188,188,240,240,240,241,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153, 26, 26, 26,240,240,240,241,241,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153, 26, 26, 26,240,240,241,241,242,242, 25,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153, 26, 26, 27, 27,241,241,242,242,243, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159, 26, 27, 27, 27, 27,242,242,243,243, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194, 27, 27,243,243,243, 25,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194,194,194,194,243,243,226,226,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24, 
24, 24, 24,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24, 
24, 24, 24,165,165,165,165,165,165,165,128,128,128,
 32, 32, 32, 64, 64, 64, 64, 64, 64, 64, 99, 99, 99, 99, 99, 24, 24, 24, 24, 
24, 24, 24,165,165,165,165,165,165,165,128,128,128,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105, 24, 24, 24, 24, 
24,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 70,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 70, 23,105,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 70, 23, 23, 23,105,105,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 37, 37, 37, 70, 70, 70, 70, 23, 23, 23, 23, 23, 23,105,105,105,136,136,136,
136,136,136,170,170,170,170,170,170,170,203,203,203,
 43, 43, 43, 76, 76, 76, 76, 76, 23, 23, 23, 23,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 23, 23,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 23,111,111,111,111,111,111,142,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111,111, 22, 22,142,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111, 22, 22, 22, 22,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 43, 43, 43, 76, 76, 76, 76, 76, 76, 76,111,111,111,111, 22, 22, 22, 22,142,
142,142,142,176,176,176,176,176,176,176,209,209,209,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116, 22, 22, 22, 22,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116, 22, 22,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 49, 49, 49, 82, 82, 82, 82, 82, 82, 82,116,116,116,116,116,116,147,147,147,
147,147,147,182,182,182,182,182,182,182,215,215,215,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153,  7, 26,238,188,188,188,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153, 26, 26, 26,188,188,240,240,221,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153,153, 26, 26, 26, 26,240,240,240,241,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153, 26, 26, 26, 26, 26,240,240,241,241,221,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153, 26, 26, 26, 26, 26,240,241,241,242,242,221,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153, 26, 26, 26, 26, 26,241,241,242,242,243,243,
 55, 55, 55, 88, 88, 88, 88, 88, 88, 88,121,121,121,121,121,121,153,153,153,
153,153, 26, 26, 26, 26, 27, 27,242,242,243,243,243,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159, 26, 26, 26, 27, 27, 27, 27,243,243,243,244,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194, 27, 27, 27, 27, 27,243,243,244,244,
 59, 59, 59, 93, 93, 93, 93, 93, 93, 93,126,126,126,126,126,126,159,159,159,
159,159,159,194,194,194, 27, 27, 27,243,244,244,244,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100, 24,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100, 24,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100, 24,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 23,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 23, 23, 23, 23,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 23, 23, 23, 23, 23, 23,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 44, 44, 44, 77, 77, 77, 77, 77, 23, 23, 23, 23,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 23, 23, 23,227,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 23,227,227,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227,227,227, 22, 22,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227,227, 22, 22, 22, 22,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227, 22, 22, 22, 22, 22, 22,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117, 22, 22, 22, 22, 22, 22,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117, 22, 22,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26, 26, 26,189,189,241,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26, 26, 26, 26,241,241,242,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154, 26, 26, 26, 26, 26, 26,241,242,242,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154, 26, 26, 26, 26, 26, 27,242,242,243,243,243,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154, 26, 26, 26, 26, 27, 27, 27,243,243,243,244,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160, 26, 26, 27, 27, 27, 27,243,243,244,244,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195, 27, 27, 27, 27,243,244,244,244,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195,195,195,195, 27,244,244,244,245,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100,137,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100,137,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100,137,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 23,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 23, 23, 23, 23,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 23, 23, 23, 23, 23, 23,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 44, 44, 44, 77, 77, 77, 77, 77, 23, 23, 23, 23,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 23, 23, 23,227,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 23,227,227,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227,227,227, 22, 22,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227,227, 22, 22, 22, 22,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227, 22, 22, 22, 22, 22, 22,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117, 22, 22, 22, 22, 22, 22,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117, 22, 22,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154,189,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154,189,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26, 26,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26, 26, 26, 26,189,242,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154, 26, 26, 26, 26, 26, 26, 27,243,243,243,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154, 26, 26, 26, 26, 26, 27, 27,243,243,244,244,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160, 26, 26, 26, 27, 27, 27,243,244,244,244,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195,195,195,195, 27,244,244,244,245,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195,195,195,195,195,244,244,245,245,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100,137,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100,137,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
249,249,249, 65, 65, 65, 65, 65, 65, 65,100,100,100,100,100,100,137,137,137,
137,137,137,127,127,127,127,127,127,127,253,253,253,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 71,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 71, 23,106,106,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 71, 23, 23, 23, 23,106,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 38, 38, 38, 71, 71, 71, 71, 23, 23, 23, 23, 23, 23,106,106,106,143,143,143,
143,143,143,171,171,171,171,171,171,171,204,204,204,
 44, 44, 44, 77, 77, 77, 77, 77, 23, 23, 23, 23,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 23, 23, 23,227,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 23,227,227,227,227,227,227,177,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227,227,227, 22, 22,177,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227,227, 22, 22, 22, 22,177,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 44, 44, 44, 77, 77, 77, 77, 77, 77, 77,227,227,227, 22, 22, 22, 22, 22, 22,
177,177,177,210,210,210,210,210,210,210,231,231,231,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117, 22, 22, 22, 22, 22, 22,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117, 22, 22,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 50, 50, 50, 83, 83, 83, 83, 83, 83, 83,117,117,117,117,117,117,148,148,148,
148,148,148,183,183,183,183,183,183,183,216,216,216,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154,189,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154,189,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154,189,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154,189,189,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26,189,189,189,189,189,222,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26, 26, 26,189,189,243,243,222,222,
 56, 56, 56, 89, 89, 89, 89, 89, 89, 89,122,122,122,122,122,122,154,154,154,
154,154,154, 26, 26, 26, 26, 27, 27,243,244,244,244,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195,195,195,195, 27,244,244,244,245,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195,195,195,195,195,244,244,245,245,
251,251,251, 94, 94, 94, 94, 94, 94, 94,229,229,229,229,229,229,160,160,160,
160,160,160,195,195,195,195,195,195,244,245,245,255,
};

const BYTE g_abWin95ToNT4[256] ={
  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,216,217,218,219,220,221,
222,223,227,226,225,224,215,186,182,241, 31,240, 32,242,243,244,
245, 66,187, 36, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21,
 22, 23, 24, 25, 26, 27, 28, 29, 30, 33, 34, 35, 37, 38, 39, 40,
 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56,
 57, 58, 59, 60, 61, 62, 63, 64, 65, 67, 68, 69, 70, 71, 72, 73,
 74, 75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89,
 91, 92, 93, 94, 95, 96, 97, 98,100,101,102,103,104,106,107,150,
185,127,118,112,113,109,116,111,119,114,121,122,117,124,125,120,
128,129,130,131,132,133,134, 99,136,137,138,139,140,135,142,143,
144,145,110,147,148,149,115,152,153,154,155,156,157,158,123,160,
161,126,163,164,165,166,167,168,169,170,171,172,173,174,175,176,
141,178,179,180,146,183,184,151,188,189,190,191,192,193,194,159,
196,197,162,199,200,201,202,203,204,205,206,207,208,209,210,211,
177,213,214, 90,105,108,195,198,212,181,228,229,230,231,233,232,
234,235,236,237,238,239,246,247,248,249,250,251,252,253,254,255,
};

const BYTE g_abWin95ToNT5[256] ={
  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  0,  0, 14, 14, 14, 15,
 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 11, 30, 31,
 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 10, 12, 62, 63,
 64, 65, 13, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
 96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,
};
